## # test cases for Ocl expressions

from ocl import *
from absyn import *

# VariabeExp
print
print '--------------------test VariableExp-------------------------------'
L = ['Aa', 'A12df', 'X2_3f', 'ab::ce']
for x in L:
    oclSrc = "inv: " + x
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b

# test EnumLiteralExp
print
print '--------------------test EnumLiteralExp-------------------------------'
L = ['A12df:::a', 'ab::ce:::e']
for x in L:
    oclSrc = "inv: " + x
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print

# CollectionLiteralExp
print
print '--------------test CollectionLiteralExp with cycle test---------------'
L = ['Set{1}','Set{}', 'Bag{}', 'Sequence{Set{12,3},Bag{1,3},Sequence{1}}']
for x in L:
    oclSrc = "inv: " + x
    print oclSrc
    for i in range(10):
        a = ocl_Parse(oclSrc)
        oclSrc = 'inv: ' + a.traverse()
    print oclSrc
    print

# IntegerLiteralExp
print
print '--------------------test IntegerLiteralExp-------------------------------'
## negative number parse error
L = ['12', '1223', '0']
for x in L:
    oclSrc = "inv: " + x
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print

# RealLiteralExp
print
print '--------------------test RealLiteralExp-------------------------------'
## negative number parse error
L = ['12.23', '.1223', '0.34e23', '9E-34']
for x in L:
    oclSrc = "inv: " + x
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print

# BooleanLiteralExp
print
print '--------------------test BooleanLiteralExp-------------------------------'
L = ['true', 'false']
for x in L:
    oclSrc = "inv: " + x
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print

# TupleLiteralExp
print
print '--------------------test TupleLiteralExp-------------------------------'
L = ['Tuple{}', 'Tuple{a:A=12, b, c:C}']
for x in L:
    oclSrc = "inv: " + x
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print

# IteratorExp
print
print '--------------------test IteratorExp-------------------------------'
L = ['select','collect','reject','exists','isUnique','forAll','sortedBy','any','one','collectNested']
L2 = ["", 'a:A', 'a']
L3 = ['a>0']
source = 'A'
for colop in L:
    for iterator in L2:
        for body in L3:
            oclSrc = "inv: "+source+'->'+colop+'('+iterator+'|'+body+')'
            a = ocl_Parse(oclSrc)
            b = a.traverse()
            print b
            print

# IterateExp
print
print '--------------------test IterateExp-------------------------------'
L = ["", 'a:A', 'a']
L2 = ['b','b:B','b:B=Set{}']
L3 = ['a>0']
source = 'A'
for iterator in L:
    for result in L2:
        for body in L3:
            oclSrc = "inv: "+source+'->iterate'+'('+iterator+';'+result+'|'+body+')'
            a = ocl_Parse(oclSrc)
            b = a.traverse()
            print b
            print

# OperationCallExp
print
print '--------------------test OperationCallExp-------------------------------'
# test predefined op which accepts exactly one argument
print 'test predefined op which accepts exactly one argument'
L = ['5','a','2.3']
L2 = ['2.3','b','0']
L3 = ['+','-','*','/','and','or','xor','=','<>','>','>=','<','<=','implies']
for source in L:
    for argument in L2:
        for op in L3:
                oclSrc = "inv: " + source + " " + op + " " + argument
                a = ocl_Parse(oclSrc)
                b = a.traverse()
                print b
                print
            
#test op which defined in the UML model
print 'test op which defined in the UML model with arbitrary number of args'
L = ['myOp']
L2 = [' ', '@pre']
L3 = ['()', '(1)', '(c.foo(),x)', '(0, x, 2+3*4)']
source = 'A'
for op in L:
    for timeExpr in L2:
        for args in L3:
            oclSrc = "inv: " + source + "." + op + timeExpr + args
            a = ocl_Parse(oclSrc)
            b = a.traverse()
            print b
            print

# test ocl standard library collection related ops
L = ['size','includes','excludes','count','includesAll','excludesAll','isEmpty',\
     'notEmpty','sum','union','intersection','including','excluding',\
     'symmetricDifference','flatten','asSet','asBag','asSequence','append',\
     'prepend','subSequence','at','first','last']
for op in L:
    oclSrc = "inv: C->" + op + '()'
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print
    
#test "not" op
a = ocl_Parse("inv: not expr")
b = a.traverse()
print b
print
            
#test AttrOrNavCallExp
print
print '--------------------test AttrOrNavCallExp-------------------------------'
L = ['Attr']
L2 = [' ', '@pre']
source = 'A'
for attr in L:
    for timeExpr in L2:
            oclSrc = "inv: " + source + "." + attr + timeExpr
            a = ocl_Parse(oclSrc)
            b = a.traverse()
            print b
            print
            
#test IfExp
print
print '---------------------------test IfExp------------------------------------'
oclSrc = "inv: if (a.manager=true) then a.salary>5000 else a.salary<=5000 endif" 
a = ocl_Parse(oclSrc)
b = a.traverse()
print b
print
            
#test OclMessageExp
print
print '----------------------test OclMessageExp---------------------------------'
L = ['12,14', '?, a', '?:G, ?']
for args in L:
    oclSrc = "inv: (observer^update(" + args + ")).isSent()" 
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print
            
#test LetExp
print
print '----------------------------test LetExp----------------------------------'
L = ['Let a:Money=self.salary in ((a+b)>5000)', 'Let a:Money=self.salary; b:Money=Company.average in (a>b)']
for letExp in L:
    oclSrc = "inv: " + letExp 
    a = ocl_Parse(oclSrc)
    b = a.traverse()
    print b
    print

 
print '--------------test complicated Ocl expression with cycle test--------------'
print '## test case1: OclExpression with letExp and ifExp'
print "The oclSrc"
oclSrc = "\
inv:\n\
Let signal:Signal = typedAst.target.type.lookupsignal(sgn) in ( \n\
if signal->isEmpty() then \n\
    typedAst.sentSignal->isEmpty() \n\
else\
    (typedAst.sentSignal->notEmpty() and \n\
    typedAst.sentSignal.signal = signal) \n\
endif) "
print oclSrc
print
for i in range(10):
    a = ocl_Parse(oclSrc)
    oclSrc = "inv:\n" + a.traverse()
print "The output after 10 passes"
print oclSrc
print


print '## test case2:'
print "The oclSrc"
oclSrc = "\
post:\n\
Let foundOperation : Operation = \n\
  namedElements->select( | mayBeImplicit) \n\
    ->any( ne | not ne.getType().lookupOperation(name, params).oclIsUndefined() ) in ( \n\
  result = if foundOperation.olcIsUndefined() then \n\
             self.parent.lookupImplicitOperation(name) \n\
           else \n\
             foundOperation \n\
           endif ) "
print oclSrc
print
for i in range(10):
    a = ocl_Parse(oclSrc)
    oclSrc = "post:\n" + a.traverse()
print "The output after 10 passes"
print oclSrc
print


print '## test case3:'
oclSrc = "\
inv: a.attr + b.op(1, c) * ( Set{1,2}->size() + 1.2) = 20 and \n\
     Company.employees->forAll(e:Person | e.married = true) implies \n\
     server^update(10).isSent()"
print oclSrc
for i in range(10):
    a = ocl_Parse(oclSrc)
    oclSrc = "inv:\n" + a.traverse()
print oclSrc
print

